PROCEDURE CalcError (ErrNum: INTEGER; Message_: ErrString);
var str1: string;
BEGIN
  CASE ErrNum OF
    1: str1 := 'Gleitkommaueberlauf';
    2: str1 := 'Division durch Null';
    3: str1 := 'Argumentfehler in ';
  END;
  if showerror then begin
    showerror := (mryes = messagedlg(pchar(str1+' '+message_)+#10#13+
                'Wollen sie eventuelle weitere Fehler sehen ?',Mterror,[mbYes,mbNo],-1));
    form1.mainmenu1.items[1].items[5].checked := showerror;
  end;
  CalcResult := FALSE;
END;

(* ----------------------------------------------------------------------- *)
(* Ein nicht mehr benoetigtes Calc-Prog. (UPN_Queue) wieder aus dem Heap   *)
(* entfernen! Wird bei fehlerhafter Uebersetzung von 'CompileExpression'   *)
(* aufgerufen, um erzeugten 'Muell' wieder zu entfernen. Sollte vom Anwen- *)
(* der fuer nicht mehr benoetigte, uebersetzte Ausdruecke benutzt werden,  *)
(* um keinen Heap-Ueberlauf zu provozieren!                                *)

PROCEDURE KillExpression (VAR ExprPtr: Calc_Prog);

VAR NextPtr: Calc_Prog;

BEGIN
   WHILE ExprPtr <> NIL DO
   BEGIN
      NextPtr := ExprPtr^.NextInst;  Dispose(ExprPtr);  ExprPtr := NextPtr
   END;
   ExprPtr := NIL;
END;

(* ----------------------------------------------------------------------- *)
(* Eine neue, leere Variablen-Tabelle im Heap anlegen. Siehe dazu Begleit- *)
(* artikel, 'CompileExpression' und 'CalcExpression'.                      *)

FUNCTION NewVarTab: Calc_VarTab;

VAR VarTab: Calc_VarTab;

BEGIN
  New(VarTab);
  VarTab^[0].Value := 0.0;
  NewVarTab := VarTab
END;

(* ----------------------------------------------------------------------- *)
(*  Eine nicht mehr benoetigte Variablen-Tabelle aus dem Heap entfernen:   *)

PROCEDURE KillVarTab (VAR VarTab: Calc_VarTab);

BEGIN  if vartab <> nil THEN Dispose(VarTab);  VarTab := NIL  END;

(* ----------------------------------------------------------------------- *)
(*  Variable mit dem Bezeichner 'Id' in Tabelle 'VarTab' suchen. Ist sie   *)
(*  nicht enthalten, wird der Wert 0 zurueckgegeben, sonst der Index in    *)
(*  die Tabelle.                                                           *)

FUNCTION SearchVarTab (VarTab: Calc_VarTab; Id: Calc_String): INTEGER;

VAR i: INTEGER;

BEGIN
 if vartab <> nil THEN
 BEGIN
   FOR i := 1 to Length(id) do id[i] := upcase(id[i]);
   i := Trunc(VarTab^[0].Value); VarTab^[0].VarId := Copy(Id, 1, Calc_IdLen);
   WHILE VarTab^[i].VarId <> Id DO i := Pred(i);
   SearchVarTab := i
 END
 ELSE SearchVarTab := 0
END;

(* ----------------------------------------------------------------------- *)
(* Variable mit dem Bezeichner 'Id' in Tabelle 'VarTab' an naechste freie  *)
(* Position aufnehmen. Zurueckgegeben wird diese Position. Ist kein Platz  *)
(* mehr in der Tabelle, wird -1 zurueckgegeben.                            *)

FUNCTION AddToVarTab (VarTab: Calc_VarTab; Id: Calc_String): INTEGER;

VAR i: INTEGER;

BEGIN
 if VarTab <> nil THEN
 BEGIN
   FOR i := 1 to Length(id) do id[i] := upcase(id[i]);
  i := Trunc(VarTab^[0].Value);
  IF i < Calc_MaxVar THEN
     BEGIN
        i := Succ(i);  VarTab^[0].Value := i;
        VarTab^[i].VarId := Id;  VarTab^[i].Value := 0
     END
  ELSE i := -1;
  AddToVarTab := i
  END
  ELSE AddToVarTab := -1
END;

(* ----------------------------------------------------------------------- *)
(* Variable an der Position 'i' in einer Variablen-Tabelle den Wert 'x'    *)
(* zuweisen:                                                               *)

PROCEDURE AssignVarI (VarTab: Calc_VarTab; i: INTEGER; x: Calc_Operand);

BEGIN
 if vartab <> nil THEN
 BEGIN
   IF (i > 0) AND (i <= Trunc(VarTab^[0].Value)) THEN
      VarTab^[i].Value := x
   ELSE
      CalcError(0, 'Wertzuweisung an unbekannte Variable')
 END
 ELSE CalcError(0, 'Wertzuweisung an unbekannte Variable')
END;

(* ----------------------------------------------------------------------- *)
(*             ...  und der Variablen mit Bezeichner 'Id':                 *)

PROCEDURE AssignVar (VarTab: Calc_VarTab; Id: Calc_String; x: Calc_Operand);

BEGIN  AssignVarI(VarTab, SearchVarTab(VarTab, Id), x)  END;

