Procedure PlotFunction(auf : TCanvas;w,h:Integer;xmin,xmax,ymin,ymax:double;grad: integer);
   Var x,d,
       f1,f2        : double;
       ok           : BOOLEAN;
       nu           : TPoint;
       int1,int2,h_ : integer;
       str1         : string;

   Const scalax = 10;
         scalay = 10;


Procedure Point (x,y :Integer);
Begin
 With auf do pixels[x,y]:= pen.color;
End;


Procedure Line (x1,y1,x2,y2 :Integer);
Begin
  With auf do begin
    moveto (x1, h-y1);
    lineto (x2, h-y2);
  end;
End;

  PROCEDURE worldtoscreen (x,y :double; VAR xs,ys :INTEGER);
  VAR a,b : double;
  BEGIN
    a := (x - xmin)*w/(xmax-xmin);
    b := (y - ymin)*h/(ymax-ymin);
    IF Abs(a) > 320000.0
      THEN
        a := sign(a)*320000.0;
    IF Abs(b) > 320000.0
      THEN
        b := sign(b)*320000.0;
    xs := Round(a);
    ys := Round(b);
    if ys < 0 then ys := 0;
  END;

  Procedure DrawLine (x1,y1,x2,y2 :double);
    Var xp1,yp1,xp2,yp2 :Integer;
    Begin
      WorldToScreen (x1, y1, xp1, yp1);
      WorldToScreen (x2, y2, xp2, yp2);
      Line (xp1,yp1,xp2,yp2)
    End;


  Procedure DrawAxis;
  Var int1  : integer;
      Dist  : double;
      x_,y_ : integer;

  Begin
    WorldToScreen(0,0,nu.x,nu.y);
    nu.y := h- nu.y;
    with auf do begin
      pen.color :=clLtGray;
      font.color:= clLtGray;
      moveto(5,nu.y); lineto(w-5,nu.y);lineto(w-10,nu.y-5);lineto(w-10,nu.y+5);lineto(w-5,nu.y);
      moveto(nu.x,h-5);lineto(nu.x,5);lineto(nu.x-5,10);lineto(nu.x+5,10);lineto(nu.x,5);
      dist := (ymax-ymin)/scalay;
      for int1 := 0 to scalay-1 do begin
        Worldtoscreen(0,ymin+dist*int1,x_,y_);
        line(x_-5,y_,x_+5,y_);
        textout(x_+4,h-y_,floattostrF(ymin+dist*int1,ffgeneral,2,3));
      end;
      dist := (xmax-xmin)/scalax;
      for int1 := 0 to scalax-1 do begin
        Worldtoscreen(xmin+dist*int1,0,x_,y_);
        line(x_,y_-5,x_,y_+5);
        textout(x_,h-y_+4,floattostrF(xmin+dist*int1,ffgeneral,2,3));
      end;
    end;
  End;

BEGIN
  drawaxis;                                  (* Achsenkreuz zeichnen  *)
  d := (xmax-xmin)/100;
 for int1 := 0 to maxgrad do begin
  case int1 Of
    0: auf.pen.color := ClBlack;
    1: auf.pen.color := ClGreen;
    2: auf.pen.color := clBlue;
    3: auf.pen.color := clRed;
  else auf.pen.color := ClGray end;
  x := xmin;
  f1 := fn(x,int1);
  ok := calcresult;
  f2 := fn(x+d,int1);
  ok := ok AND calcresult;
  WHILE (x+d<=xmax) DO
    BEGIN
      IF ok
        THEN
          drawline (x,f1,x+d,f2);     (* Zeichnen der Funktion *)
      x := x + d;
      f1 := fn(x,int1);
      ok := calcresult;
      f2 := fn(x+d,int1);
      ok := ok AND calcresult;
    END;
    h_:=h-(maxgrad+1-int1)*16;
    auf.brush.color := auf.pen.color;
    auf.fillrect(rect(0,h_,10,h_+4));
    auf.brush.color := clWhite;
    auf.font.color:= clBlack;
    str1:= '';
    for int2 := 1 to int1 do
      str1 := str1+'''';
    auf.Textout(13,h_-5,'f'+str1+'(x)');
  end;
END;

