PROCEDURE integrate;

TYPE integrtyp = (flaeche,rotationsvolumen,mantelflaeche,bogenlaenge);

VAR a,b,g,err,i,lasti : double;
    k                 : INTEGER;
    typ               : integrtyp;

  FUNCTION simpson (a,b :double; k :INTEGER; typ : integrtyp) : double;

  VAR h,s : double;
      i   : INTEGER;

    FUNCTION integrand(x : double ; typ : integrtyp) : double;

    BEGIN
      result := 0;
      CASE typ OF
        flaeche           : integrand := fn(x,0);
        rotationsvolumen  : integrand := pi*Sqr(fn(x,0));
        mantelflaeche     : integrand := 2.0*pi*fn(x,0)*Sqrt(1.0+Sqr(fn(x,1
                                           )));
        bogenlaenge       : integrand := Sqrt(1.0+Sqr(fn(x,1)))
      END
    END;

  BEGIN
    h := (b-a)/(k+k);
    s := integrand(a,typ) + integrand(b,typ);
    FOR i:=0 TO k-1 DO
      s := s + 4*integrand(a+(i+i+1)*h,typ);
    FOR i:=1 TO k-1 DO
      s := s + 2*integrand(a+2*i*h,typ);
    simpson := s * h/3;
  END;

BEGIN
  with integralform do begin
    a:= floatedit1.value;
    b:= floatedit2.value;
    g:= floatedit3.value;
    CASE artgroup1.itemindex OF
      0 : typ := flaeche;
      1 : typ := rotationsvolumen;
      2 : typ := mantelflaeche;
      3 : typ := bogenlaenge
    END;
  end;
  k := 4;
  lasti := simpson (a, b, 2, typ);
  REPEAT
    i := simpson (a, b, k, typ);                    (* Simpson-Naeherung *)
    err := Abs ((i-lasti)/i);                        (* relativer Fehler *)
    lasti := i;
    k := k * 2                               (* Stuetzstellen verdoppeln *)
  UNTIL (err <= g) OR (k > maxiter);
  IF k <= maxiter
    THEN
      BEGIN
        showmessage('Integral:              I = '+ floattostr(i)+#13+
                    'Relativer Fehler:     dI = '+ floattostr(err));
      END
    ELSE
      BEGIN
        messagedlg('Maximale Anzahl von Iterationen ueberschritten!'+#13+
                   'Integral ungefaehr:     I = '+ floattostr(i),mtError,[mbok],-1);
      END
END;

