unit kurvend;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, eingabe, Grids, StdCtrls, inifiles, Math, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Exit1: TMenuItem;
    Hilfe1: TMenuItem;
    About1: TMenuItem;
    Formel1: TMenuItem;
    eingeben1: TMenuItem;
    zeichnen1: TMenuItem;
    Bevel1: TBevel;
    PaintBox1: TPaintBox;
    StringGrid1: TStringGrid;
    Integrale1: TMenuItem;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label9: TLabel;
    Optionen1: TMenuItem;
    Label4: TLabel;
    Label8: TLabel;
    speichern: TMenuItem;
    Label10: TLabel;
    StringGrid3: TStringGrid;
    Label11: TLabel;
    StringGrid2: TStringGrid;
    Label12: TLabel;
    StringGrid4: TStringGrid;
    Fehlerzeigen1: TMenuItem;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    SaveDialog1: TSaveDialog;
    Graphspeichern1: TMenuItem;
    SaveDialog2: TSaveDialog;
    Wertetabellespeichern1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure eingeben1Click(Sender: TObject);
    procedure Integrale1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Optionen1Click(Sender: TObject);
    procedure Fehlerzeigen1Click(Sender: TObject);
    procedure zeichnen1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure speichernClick(Sender: TObject);
    procedure Graphspeichern1Click(Sender: TObject);
    procedure Wertetabellespeichern1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

CONST
{$I CALCCONS.PAS }
maxgrad = 3;

TYPE
{$I CALCTYPE.PAS }
strg = calc_string;

Const MaxIter  = 1000;
 NoPoints = 20;
 d =1;

VAR
  VarTable : Calc_VarTab;
  ArgPos   : INTEGER;
  FormProg : ARRAY [0..maxgrad] OF Calc_prog;
  FuncTerm : Calc_String;
  Form1: TForm1;
  xmin,xmax, dx:  double;
  CalcDecMod,first,
  CalcResult : BOOLEAN;

CONST Calc_Ids : ARRAY [Calc_Symbols] OF Calc_IdStr =
                   ('ERR', ';', 'CONST', 'VAR', 'PI', 'E', '(', ')', 'NEG',
                    '+', '-', '*', '/', 'DIV', 'MOD', 'GGT', 'KGV', '^',
                    'SQR', 'SQRT', 'EXP', 'LN', 'LG', 'LD',
                    'SIN', 'COS', 'TAN', 'COT',
                    'ARCSIN', 'ARCCOS', 'ARCTAN', 'ARCCOT',
                    'SINH', 'COSH', 'TANH', 'COTH',
                    'ARSINH', 'ARCOSH', 'ARTANH', 'ARCOTH',
                    'INT', 'SIGN',
                    'ABS', 'DEG', 'RAD', 'REZ', 'FAK', '@end@');
      eps     : double = 1e-07;
      showerror : boolean = True;


implementation

uses about, optionen, integra;

{$R *.DFM}

{$I CALCUTIL.PAS }                        (* Hilfsroutinen fuer Calc         *)
{$I MATHFUNC.PAS }                        (* Funktionensammlung              *)
{$I CALC.PAS }                            (* Compiler und Interpreter        *)
{$I CALCGLOB.PAS }                        (* globale Prozeduren fuer Calcderi*)
{$I CALCSIMP.PAS }                        (* Vereinfachen von Calc-Termen    *)
{$I CALCSIM2.PAS }                        (*       "       "    " , Teil 2   *)
{$I CALCDERI.PAS }                        (* symbolisches Differenzieren     *)
{$I CALCAOS.PAS }                         (* Bildschirmausgabe               *)
{$I FORMULA.INC }                         (* erlaubt Eingabe von z.B. 1/7    *)
{$I FUNCTION.INC}                         (* Funktionseingabe und Auswertung *)
{$I SOLVE.INC   }                         (* Loesen der Gleichung f(x)=0     *)
{$I TABLE.INC   }                         (* Erstellen einer Wertetabelle    *)
{$I ROOTS.INC   }                         (* Berechnung der Nullstellen      *)
{$I EXTREME.INC }                         (*      -      -  Extremwerte      *)
{$I FLEX.INC    }                         (*      -      -  Wendestellen     *)
{$I INTEGRAL.INC}                         (* Integralberechnung              *)
{$I SYMMETRY.INC}                         (* Symmetrieueberpruefung          *)
{$I DRAW.INC}                             (* Funktion zeichnen               *)

procedure TForm1.Exit1Click(Sender: TObject);
begin
  halt;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
   CalcDecMod := TRUE;                  (* nur vereinbarte Variable zulassen *)
   vartable := newvartab;               (* Variablenliste anlegen *)
   ArgPos := AddToVarTab(vartable,'X'); (* Variable ist 'X' *)
   FOR I := 0 to maxgrad do
      FormProg[I] := Nil;               (* noch keine Funktion eingegeben *)
   first := false;
end;

procedure TForm1.eingeben1Click(Sender: TObject);
begin
  getfunction;
  CheckSymmetry;
  FindRoots;
  FindExtremeValues;
  FindFlexPoints;
  Table;
end;

procedure TForm1.Integrale1Click(Sender: TObject);
begin
  if mrok = integralform.showmodal then begin
    integrate;
  end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  aboutform.show;
end;

procedure TForm1.Optionen1Click(Sender: TObject);
var f: TIniFile;
begin
  optionenform.showmodal;
  if optionenform.ModalResult = mrOk then begin
    f := Tinifile.Create('kurvend.ini');
    f.Writestring('','von',optionenform.edit1.text);
    f.Writestring('','bis',optionenform.edit2.text);
    f.WriteBool('','autozoom',optionenform.checkbox1.checked);
    f.WriteBool('','Mitte',optionenform.checkbox2.checked);
    f.WriteBool('','ratio',optionenform.checkbox3.checked);
    f.Writestring('','genauigkeit 10^-',optionenform.edit3.text);
    eps := power(10,strtoint(optionenform.edit3.text));
    f.Writestring('','xmin',optionenform.edit4.text);
    f.Writestring('','xmax',optionenform.edit5.text);
    f.Writestring('','ymin',optionenform.edit6.text);
    f.Writestring('','ymax',optionenform.edit7.text);
    f.writestring('','schrittweite',optionenform.edit8.text);
    f.free;
    xmin := strtofloat(optionenform.edit1.text);
    xmax := strtofloat(optionenform.edit2.text);
    dx := strtofloat(optionenform.edit8.text);
  end;
  CheckSymmetry;
  FindRoots;
  FindExtremeValues;
  FindFlexPoints;
  Table;
  paintbox1.repaint;
end;

procedure TForm1.Fehlerzeigen1Click(Sender: TObject);
begin
  with mainmenu1.items[1].items[5] do begin
    checked := NOT checked;
    showerror := checked;
  end;
end;

procedure TForm1.zeichnen1Click(Sender: TObject);
var w, h                : integer;
    x1,x2,y1,y2, u ,u2  : double;
    ok                  : boolean;

begin
  if optionenform.checkbox1.checked  OR False then begin 
    u := -2;
    x1 := solve(xmin,xmax,dx,0,ok);
    if ok then u := minvalue([x1,u]);
    x1 := solve(xmin,xmax,dx,1,ok);
    if ok then u := minvalue([x1,u]);
    x1 := solve(xmin,xmax,dx,2,ok);
    if ok AND (fn(x1,3)<>0) then u := minvalue([x1,u]);
    x1 := u - abs(u/10);
    u := 2;
    x2 := solve(xmax,xmin,-dx,0,ok);
    if ok then u := maxvalue([x2,u]);
    x2 := solve(xmax,xmin,-dx,1,ok);
    if ok then u := maxvalue([x2,u]);
    x2 := solve(xmax,xmin,-dx,2,ok);
    if ok AND (fn(x2,3)<>0) then u := maxvalue([x2,u]);
    x2 := u + abs(u/10);
    if abs(x1 - x2) < eps then begin x1:= -10; x2 := 10; end;
    y1 := -2;
    y2 := 2;
    u2 := xmin;
    repeat
      u := solve(u2,xmax,dx,1,ok);   {nur Extrema bercksichtigen}
      if ok then begin
        u2 := u+eps;
        u:= fn(u,0);
        if y1 > u then y1 := u - abs(u/10);
        if y2 < u then y2 := u + abs(u/10);
      end else u2 := xmax;
    until u2 >= xmax;
    if abs(y1 - y2) < eps then begin y1 := -10; y2:= 10; end;
    if optionenform.checkbox2.checked then begin
      x1 := -maxvalue([abs(x1),abs(x2)]);
      x2 :=  maxvalue([abs(x1),abs(x2)]);
      y1 := -maxvalue([abs(y1),abs(y2)]);
      y2 :=  maxvalue([abs(y1),abs(y2)]);
    end;
    if optionenform.checkbox3.checked then begin
      x1 := -maxvalue([abs(x2),abs(y2)]);
      x2 :=  maxvalue([abs(x2),abs(y2)]);
      y1 := -maxvalue([abs(y2),abs(x2)]);
      y2 :=  maxvalue([abs(y2),abs(x2)]);
    end;
  end else begin
    x1 := strtofloat(optionenform.edit4.text);
    x2 := strtofloat(optionenform.edit5.text);
    y1 := strtofloat(optionenform.edit6.text);
    y2 := strtofloat(optionenform.edit7.text);
  end;
  w:= paintbox1.width;
  h:= paintbox1.height;
  with paintbox1.Canvas do begin
    FillRect(clientrect);
  end;
  plotfunction(form1.paintbox1.canvas,w,h,x1,x2,y1,y2,0);
  first := true;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  if first then zeichnen1Click(Sender);
end;

procedure TForm1.speichernClick(Sender: TObject);
 var f: textfile;
     int1,int2 : integer;

begin
 if savedialog1.execute then begin
   assignfile(f,savedialog1.filename);
   rewrite(f);
   writeln(f,'          KURVENDISKUSSION');
   writeln(f,'              by (c) 1986,87,88'+#13#10+
            'Karsten Gieselmann, Michael Ceol, Peter Engels& PASCAL International'+#10#13+
            'Umgeschrieben fr Delphi:     Leonhard Klein      Mai.1999');
   writeln(f,'f(x)='+form1.edit1.text);
   writeln(f,'f''(x)='+form1.edit2.text);
   writeln(f,'f''''(x)='+form1.edit3.text);
   writeln(f,'f''''''(x)='+form1.edit4.text);
   writeln(f);
   writeln(f,form1.label9.caption);
   writeln(f,'Nullstellen:');
   for int1 := 0 to form1.stringgrid3.colcount do
     writeln(f,form1.stringgrid3.cells[int1,0]);
   writeln(f);
   writeln(f,'Monotonie');
   with form1.stringgrid2 do
    for int2 := 0 to 2 do begin
      for int1 := 0 to colcount do
        write(f, cells[int1,int2]:10);
   writeln(f);
   end;
   writeln(f,'Krmmung:');
   with form1.stringgrid4 do
    for int2 := 0 to 1 do begin
      for int1 := 0 to colcount do
        write(f, cells[int1,int2]:10);
   writeln(f);
   end;
   closefile(f)
 end;
end;

procedure TForm1.Graphspeichern1Click(Sender: TObject);
var c : TPicture;
begin
  paintbox1.repaint;
  if savedialog2.execute then begin
    c := TPicture.create;
    c.Bitmap.Width := paintbox1.ClientWidth;
    c.Bitmap.Height:= paintbox1.ClientHeight;
    c.Bitmap.Canvas.copyrect(rect(0,0,c.bitmap.width,c.bitmap.height),paintbox1.canvas,paintbox1.clientrect);
    c.bitmap.savetofile(savedialog2.filename);
    c.destroy;
  end;
end;

procedure TForm1.Wertetabellespeichern1Click(Sender: TObject);
 var f: textfile;
     i : double;
begin
   if not savedialog1.execute then exit;
   assignfile(f,savedialog1.filename);
   rewrite(f);
   writeln(f,'          KURVENDISKUSSION');
   writeln(f,'              by (c) 1986,87,88'+#13#10+
            'Karsten Gieselmann, Michael Ceol, Peter Engels& PASCAL International'+#10#13+
            'Umgeschrieben fr Delphi:     Leonhard Klein      Mai.1999');
   writeln(f,'f(x)='+form1.edit1.text);
   writeln(f);
   writeln(f);
   Writeln(f,'      X          f(x)       f''(x)         f''''(x)       f''''''(x)');
   i := xmin;
   while i < xmax do begin
     writeln(f,i:12:4,fn(i,0):12:4,fn(i,1):12:4,fn(i,2):12:4, fn(i,3):12:4);
     i:= i + dx;
   end;
   closefile(f);
end;

end.
